# HC_SCORE.py : Les methodes de scores

import math
import string
import sys
ALPHA = string.ascii_uppercase
#=========================================
def initWRD( fic_wrd ):
    global lesWRD
    f_word = open( "STATS/" + fic_wrd + ".wrd", "r")
    while 1:
        ch = f_word.readline()
        if ch == "":break
        ch = ch.strip()
        lesWRD[ch] = 1
#=========================================
def initIC( fic_IC ):
    1
#=========================================
def initIC2( fic_IC ):
    1
#=========================================
def initPlain( begin ):
    global lePlain
    lePlain = begin
#===========Unigram=======================
def initUni( fic_uni ):
    global lesUni
    for i in range(26):
        lesUni.append( 0. )
    f_uni = open( "STATS/" + fic_uni + ".uni", "r")
    while 1:
        ch = f_uni.readline()
        if ch == "":break
        ch = ch.strip()
        (uni,fre) = ch.split(',')
        i = ALPHA.index(uni)
        #lesUni[i]= math.log(int(fre))
        lesUni[i]= float(fre)
    #for i in range(26):
    #    print lesUni[i],
    print
#===========Bigrammes=====================
def initBig( fic_big ):
    global lesBig
    for i in range(26*26):
        lesBig.append( 1. )

    #f_big = open(english.big","r")
    f_big = open( "STATS/" + fic_big + ".big" , "r" )
    while 1:
        ch = f_big.readline()
        if ch == "": break
        ch = ch.strip()
        (big,fre) = ch.split(',')
        #print "<",big, "=", fre, ">"
        i1 = ALPHA.index(big[0])
        i2 = ALPHA.index(big[1])
        lesBig[ i1*26 + i2 ] = math.log(int(fre))

#===========Trigrammes=====================
def initTri( fic_tri ):
    global lesTri
    for i in range(26*26*26):
        lesTri.append( 1. )

    f_tri = open( "STATS/" + fic_tri + ".tri" ,"r")
    while 1:
        ch = f_tri.readline()
        if ch == "": break
        ch = ch.strip()
        (tri,fre) = ch.split(',')
        #print "<",tri, "=", fre, ">"
        i1 = ALPHA.index(tri[0])
        i2 = ALPHA.index(tri[1])
        i3 = ALPHA.index(tri[2])
        lesTri[ i1*26*26 + i2*26 + i3 ] = math.log(int(fre))
#===============================================
def initQua( fic_qua ):
    global lesQua
    f_qua = open( "STATS/" + fic_qua + ".qua","r")
    while 1:
        ch = f_qua.readline()
        if ch == "": break
        ch = ch.strip()
        (qua,fre) = ch.split(',')
        #print "<",qua, "=", fre, ">"
        lesQua[qua]=math.log(int(fre))
#===============================================
def initPnt( fic_pnt ):
    global lesPnt
    f_pnt = open( "STATS/" + fic_pnt + ".pnt","r")
    while 1:
        ch = f_pnt.readline()
        if ch == "": break
        ch = ch.strip()
        (pnt,fre) = ch.split(',')
        #print "<",pnt, "=", fre, ">"
        lesPnt[pnt]=math.log(int(fre))
#===============================================
def initHex( fic_hex ):
    global lesHex
    f_hex = open( "STATS/" + fic_hex + ".hex","r")
    while 1:
        ch = f_hex.readline()
        if ch == "": break
        ch = ch.strip()
        (hxe,fre) = ch.split(',')
        #print "<",hxe, "=", fre, ">"
        lesHex[hxe]=math.log(int(fre))
#================================================
def initSep( fic_sep ):
    global lesSep
    f_sep = open( "STATS/" + fic_sep + ".sep","r")
    while 1:
        ch = f_sep.readline()
        if ch == "": break
        ch = ch.strip()
        (sep,fre) = ch.split(',')
        if int(fre) == 1: continue
        #print "<",qua, "=", fre, ">"
        lesSep[sep]=math.log(int(fre))
#================================================
def is_maj(car):
    if ALPHA.find(car) == -1:
        return 0
    else:
        return 1
# ===================================
def score_IC(texte):
    f = []
    for i in range(26):
        f.append(0)
    N = len(texte)
    for i in range(N):
        indice = ALPHA.index( texte[i] )
        f[indice] = f[indice] + 1
    total = 0
    for i in range(26):
        if ( f[i] > 1):
            total = total + f[i]*(f[i]-1)
    return total / float(N * (N-1))
#=====================================
def score_IC2(texte):
    f = []
    for i in range(676):
        f.append(0)
    N = len(texte)
    for i in range(0,N-2,2):
        index1 = ALPHA.index(texte[i])
        index2 = ALPHA.index(texte[i+1])
        indice = index1 * 26 + index2
        f[indice] += 1
    total = 0
    for i in range(676):
            if ( f[i] > 1):
                    total = total + f[i]*(f[i])
    return total / float(N * (N))
#=====================================
def score_plain(texte):
    global lePlain
    total = 0
    N = len(lePlain)
    for i in range(N):
        if texte[i] == lePlain[i]:
            total = total + 1
    return total / float(N)
#=====================================
def score_ADE(texte):
    global lePlain
    N = len(texte)
    maxds = N * 26
    for i in range(N):
        x = abs(ord(texte[i]) - ord(lePlain[i])) 
        if x > 23:
            x -= 23
        maxds = maxds - x 
    return maxds / float(N * 26)
#=====================================
def score_ADE2(texte):
    global lePlain
    N = len(texte)
    maxds = N * 26
    for i in range(N):
        x = abs(ord(texte[i]) - ord(lePlain[i]))
        if x > 13:
            x = abs( x - 26 )
        maxds -= x
    return maxds / float(N * 26 )
#=====================================
def score_uni(texte):
    global lesUni
    total = 0
    for i in range( len(texte) ):
        lettre = texte[i]
        idx = ALPHA.index( lettre )
        total += lesUni[ idx ]
    return total
#=====================================
def score_big(texte):
    global lesBig
    total = 0
    for i in range( len(texte) - 1 ):
        lettre = texte[i]
        idx1 = ALPHA.index( lettre )
    
        lettre = texte[i+1]
        idx2 = ALPHA.index( lettre )

        total += lesBig[ idx1*26 + idx2 ]
    return total / float(len(texte))
#=======================================
def score_tri(texte):
    global lesTri
    total = 0
    for i in range( len(texte) - 2 ):
        lettre = texte[i]
        idx1 = ALPHA.index( lettre )

        lettre = texte[i+1]
        idx2 = ALPHA.index( lettre )

        lettre = texte[i+2]
        idx3 = ALPHA.index( lettre )

        total += lesTri[ idx1*26*26 + idx2*26 + idx3 ]
    return total / float(len(texte))
#=======================================
def score_qua(texte):
    global lesQua
    total = 0
    for i in range( len(texte) - 3 ):
        qua = texte[i] + texte[i+1] + texte[i+2] + texte[i+3]
        if qua in lesQua:
            total += lesQua[qua]
    return total / float(len(texte))
#=======================================
def score_pnt(texte):
    global lesPnt
    total = 0
    for i in range( len(texte) - 4 ):
        pnt = texte[i] + texte[i+1] + texte[i+2] + texte[i+3] + texte[i+4]
        if pnt in lesPnt:
            total += lesPnt[pnt]
    return total / float(len(texte))
#=======================================
def score_wrd(texte):
    global lesPnt
    total = 0
    for i in range( len(texte) - 5 ):
        cri = texte[i] + texte[i+1] + texte[i+2] + texte[i+3] + texte[i+4] + texte[i+5]
        if cri in lesWRD:
            total += 1
    return total / float(len(texte))
#=======================================
def score_hex(texte):
    global lesHex
    total = 0
    for i in range( len(texte) - 5 ):
        hxe = texte[i]   + texte[i+1] + texte[i+2] + texte[i+3] + \
              texte[i+4] + texte[i+5]
        if hxe in lesHex:
            total += lesHex[hxe]
    return total / float(len(texte))
#=======================================
def score_sep(texte):
    global lesSep
    total = 0
    for i in range( len(texte) - 6 ):
        sep = texte[i]   + texte[i+1] + texte[i+2] + texte[i+3] + \
              texte[i+4] + texte[i+5] + texte[i+6] 
        if sep in lesSep:
            total += lesSep[sep]
    return total / float(len(texte))
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
lesUni = []
lesBig = []
lesTri = []
lesQua = {}
lesPnt = {}
lesHex = {}
lesSep = {}
lesWRD = {}

score_init = { 'IC':initIC, 'IC2':initIC2, 'PLN':initPlain, 
               'UNI':initUni, 'BIG':initBig, 'TRI':initTri, 
               'QUA':initQua, 'ADE':initPlain, 'ADE2':initPlain, 
               'PNT':initPnt, 'HEX':initHex, 'SEP':initSep,
               'WRD':initWRD
}
score = {   'IC':score_IC, 'IC2':score_IC2, 'PLN':score_plain, 
            'UNI':score_uni, 'BIG':score_big, 'TRI':score_tri, 
            'QUA':score_qua, 'PNT':score_pnt, 'HEX':score_hex,
            'ADE':score_ADE, 'ADE2':score_ADE2, 'SEP':score_sep,
            'WRD':score_wrd
}

