# print_pi_decal.py

from ROTOR import *
import sys

if len(sys.argv) < 2:
    print("Syntax: %s rotor_wiring" % (sys.argv[0]))
    sys.exit(1) 

PI = sys.argv[1]
if not Rotor.valide(PI):
    print("Rotor wiring is not correct")
    sys.exit(1)
c = Rotor(PI)
print("PI        : ", PI)
print("PI reverse: ", \
    Rotor.rotor2char(Rotor.decal2pi(c.PI_SHIFT_INV)))
print("PI mirror : ", Rotor.rotor2char(c.PI_MIR))
print("PI mir.rev: ", \
    Rotor.rotor2char(Rotor.decal2pi(c.SHIFT_MIR_INV)))
print("PI shift: ", c.PI_SHIFT)
print("Pi reverse shift: ", c.PI_SHIFT_INV)
print("Shift mirror: ", c.SHIFT_MIR)
print("Shift mirror reverse: ", c.SHIFT_MIR_INV)
